#!/bin/bash

files_selection()
{
    # $1 -> title
    # $2 -> text

    values_select=''
    values_default='"No Selection" "" ""'
    while : ; do
	value_pass=$(echo "$values_select" | awk -F\| 'BEGIN { aff="" } {if ($1) {aff=aff " \"" $1 "\" \"" $2 "\" on" } } END { print aff}')
	dialog_selection=$(eval Xdialog --separate-output --cancel-label \"Add File\" --title \"$1\" --checklist \"$2\" 20 60 13 ${value_pass:-$values_default} 2>&1)
	return_select=$?
	values_select=$(echo "$dialog_selection
======SEP======
$values_select" | awk -F\| 'BEGIN { first_elem=0; j=0 } first_elem == 0 { if ($0 == "======SEP======") first_elem="1"; tab[j]=$0; j = j + 1; next} { for (j = 0; tab[j]; j++) { if ($1 && tab[j] == $1) { print $1 "|" $2; next}}}')
	if [ $return_select -eq "0" ] ; then
	    echo "$values_select" | awk -F\| 'BEGIN {aff=""} {if (aff) aff=aff "|" $2 "/" $1; else aff=$2 "/" $1} END {print aff}'
	    return 0
	fi
	if [ $return_select -eq "1" ] ; then
	    dialog=`Xdialog --fselect "\`pwd\`" 40 80 9 2>&1`
	    return_select=$?
	    if [ $return_select -eq "0" ] ; then
		if [ -d "$dialog" ] ; then
		    dialog=$(echo "$dialog" | sed 's/\/$//')
		    for file in $dialog/* ; do
			if [ -e	"$file" ] ; then
			    name_file=`echo "$file" | awk -F\/ '{print $NF}'`
			    rep=`echo "$file" | sed "s/$name_file$//"`
			    values_select=$(echo "$values_select
$name_file|$rep")
			fi
		    done
		    values_select=$(echo "$values_select" | sort)
		elif [ -f "$dialog" ] ; then
		    name_file=`echo $dialog | awk -F\/ '{print $NF}'`
		    rep=`echo "$dialog" | sed "s/$name_file$//"`
		    values_select=$(echo "$values_select
$name_file|$rep" | sort)
		fi
	    fi
	fi
    done
}

entry_hide()
{
    # $1 -> title
    # $2 -> text

    Xdialog --title "$1" --password --inputbox "$2" 9 70 "" 2>&1
    return $?
}

entry_text()
{
    # $1 -> title
    # $2 -> text
    # $3 -> default entry

    Xdialog --title "$1" --inputbox "$2" 9 70 "$3" 2>&1
    return $?
}

info_text()
{
    # $1 -> title
    # $2 -> text

    Xdialog --title "$1" --msgbox "$2" 9 70
    return $?
}

radiolist_select()
{
    # $1 title
    # $2 text
    # $3 values. Must recreate data
    # $4 force height
    # $5 force width

    var="" 
    SAVE_IFS=$IFS
    IFS="
"
    for line in $3 ; do
	var="$var `echo \"$line\" | awk 'BEGIN {var=\"\"} { for (i = 2; i <= NF; i++) if (var) var=var \" \" $i; else var=$i} END {print var }'` \"\" `echo \"$line\" | awk '$1 ~ /TRUE/ { print \"on\"} $1 ~ /FALSE/ { print \"off\"}'`"
    done
    IFS=$SAVE_IFS
    eval Xdialog --title \"$1\" --radiolist \"$2\" ${4:-20} ${5:-60} 13 $var 2>&1
    return $?
}

checklist_select()
{
    # $1 title
    # $2 text
    # $3 values

    var=""
    SAVE_IFS=$IFS
    IFS="
"
    for line in $3 ; do
	var="$var `echo \"$line\" | awk 'BEGIN {var=\"\"} { for (i = 2; i <= NF; i++) if (var) var=var \" \" $i; else var=$i} END {print var}'` \"\" `echo \"$line\" | awk '$1 ~ /TRUE/ { print \"on\"} $1 ~ /FALSE/ { print \"off\"}'`"
    done
    IFS=$SAVE_IFS
    dialog_selection=$(eval Xdialog --separate-output --title \"$1\" --checklist \"$2\" 20 60 13 $var 2>&1)
    DIALOG_VAL="$?"
    echo "$dialog_selection" | awk 'BEGIN {aff=""} {if (aff) aff=aff "|" $0; else aff=$0}END { print aff}'
    return $DIALOG_VAL
}

question_select()
{
    # $1 title
    # $2 value

    Xdialog --yesno "$1" 9 70
    DIALOG_RET=$?
    echo $DIALOG_RET
    return $DIALOG_RET
}
