#!/bin/bash

OK="[[32mOK[0m]"
NO="[[31mNO[0m]"
echo "BEGINNING OF THE AUTAUMATIC INSTALLATION"
cd /tmp

for CC in gcc gcc-3.3 gcc-3.2 gcc-3.1 gcc3 gcc-3.0 cc ; do
  cc_name=`$_cc -v 2>&1 | tail -1 | cut -d ' ' -f 1`  
  cc_version=`$_cc -dumpversion 2>&1`
  if test "$?" -gt 0; then
      cc_version="not found"
  fi
  case $cc_version in
      '')
	  cc_version="v. ?.??, bad"
	  cc_verc_fail=yes
	  ;;
      2.95.[2-9]|2.95.[2-9][-.]*|3.[0-9]|3.[0-9].[0-9])
      _cc_major=`echo $cc_version | cut -d '.' -f 1`
      _cc_minor=`echo $cc_version | cut -d '.' -f 2`
      _cc_mini=`echo $cc_version | cut -d '.' -f 3`
      cc_version="$cc_version, ok"
      cc_verc_fail=no
      ;;
      'not found')
	  cc_verc_fail=yes
	  ;;
      *)
	  cc_version="$cc_version, bad"
	  cc_verc_fail=yes
	  ;;
  esac
  (test "$cc_verc_fail" = "no") && break
done 
echo "Compilateur:	$OK"


TMPC='tmp.c'
cat > $TMPC << EOF
#include <zlib.h>
int main(void) { (void) inflate(0, Z_NO_FLUSH); return 0; }
EOF

echo -n "zlib:		"
if $CC $TMPC -lz > /dev/null 2>&1 ; then
    echo "$OK"
else
    echo "$NO"
fi


cat > $TMPC << EOF 
#include <mad.h>
int main() { return 0; }
EOF

echo -n "mad:		"
if $CC $TMPC -lmad > /dev/null 2>&1 ; then
    echo "$OK"
else
    echo "$NO"
fi

cat > $TMPC << EOF
#include <vorbis/codec.h>
int main(void) { vorbis_packet_blocksize(0,0); return 0; }
EOF

echo -n "vorbis/ogg:	"
if $CC $TMPC -lvorbis -logg -lm > /dev/null 2>&1 ; then
    echo "$OK"
else
    echo "$NO"
fi


cat > ${TMPC}pp << EOF
#include <ebml/EbmlVersion.h>
#include <matroska/KaxVersion.h>

#if LIBEBML_VERSION < 000600
#error libebml is too old
#endif

#if LIBMATROSKA_VERSION < 000600
#error libmatroska is too old
#endif

int main(void) { return 0; }
EOF

echo -n "matroska:	"
if $CC ${TMPC}pp -lmatroska -lebml -lstdc++; then
    echo "$OK"
else
    echo "$NO"
fi


# FAIRE LA VERIF DE LA LIBZ
# DES LIBAUDIO
# DES CODECS
# DE MPLAYER
# DES FONTS
