#!/bin/bash

files_selection()
{
    # $1 -> title
    # $2 -> text

    val=""
    path_select_kdial="`pwd`"
    while : ; do
       value=$(kdialog --title="$2" --getopenfilename "$path_select_kdial" "*.tar *.tar.bz2 *.tgz | Archives")
       VAL_RET="$?"
       [ "$VAL_RET" -eq "1" ] && break
       if [ -z "$val" ] ; then
          val="$value"
	else
	  val="$val|$value"
       fi	
       path_select_kdial=$(echo "$value" | awk -F\/ '
BEGIN { val=""} 
{ for (i=1; i < NF; i++) if (val) val=val $i "/"; else val="/" }
END { print val}')
       echo "$path_select_kdial" > toto
       kdialog --warningcontinuecancel "Continue choosing another archives ?"
       [ "$?" -eq "2" ] && break
    done
    echo $val
    return $VAL_RET
}

entry_hide()
{
    # $1 -> title
    # $2 -> text
    
    kidalog --password "$2" --title="$1"
    return $?
}

entry_text()
{
    # $1 -> title
    # $2 -> text
    # $3 -> default entry
    
    kdialog --inputbox "$2" "$3" --title="$1"
    return $?
}

info_text()
{
    # $1 -> title
    # $2 -> text

    kdialog --msgbox $2 --title="$1" 
    return $?
}

radiolist_select()
{
    # $1 title
    # $2 text
    # $3 values. Must recreate data
    # $4 force height
    # $5 force width

    var=""
    SAVE_IFS=$IFS
    IFS="
"
    for line in $3 ; do
        var="$var `echo \"$line\" | awk 'BEGIN {var=\"\"} { for (i = 2; i <= NF;
i++) if (var) var=var \" \" $i; else var=$i} END {print var " " var}'` `echo \"$line\" | awk '$1 ~ /TRUE/ { print \"on\"} $1 ~ /FALSE/ { print \"off\"}'`"
    done
    IFS=$SAVE_IFS
    eval kdialog --title=\"$1\" --radiolist \"$2\" $var
    return $?
}

checklist_select()
{
    # $1 title
    # $2 text
    # $3 values

    var=""
    SAVE_IFS=$IFS
    IFS="
"
    for line in $3 ; do
        var="$var `echo \"$line\" | awk 'BEGIN {var=\"\"} { for (i = 2; i <= NF;
i++) if (var) var=var \" \" $i; else var=$i} END {print var " " var}'` `echo \"$line\" | awk '$1 ~ /TRUE/ { print \"on\"} $1 ~ /FALSE/ { print \"off\"}'`"
    done
    IFS=$SAVE_IFS
    dialog_selection=$(eval kdialog --separate-output --title=\"$1\" --checklist \"$2\" $var)
    DIALOG_VAL="$?"
    echo "$dialog_selection" | awk 'BEGIN {aff=""} {if (aff) aff=aff "|" $0; else
 aff=$0} END { print aff}'
    return $DIALOG_VAL
}

question_select()
{
    # $1 title
    # $2 value

    kdialog --title="$1" --yesno "$2"
    DIALOG_RET=$?
    echo $DIALOG_RET
    return $DIALOG_RET
}
